Index: CKEditor/branches/versions/3.5.x/_source/plugins/dialog/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/dialog/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/dialog/plugin.js	(revision 6050)
@@ -34,4 +34,5 @@
 (function()
 {
+	var cssLength = CKEDITOR.tools.cssLength;
 	function isTabVisible( tabId )
 	{
@@ -67,4 +68,28 @@
 
 		return null;
+	}
+
+
+	function clearOrRecoverTextInputValue( container, isRecover )
+	{
+		var inputs = container.$.getElementsByTagName( 'input' );
+		for ( var i = 0, length = inputs.length; i < length ; i++ )
+		{
+			var item = new CKEDITOR.dom.element( inputs[ i ] );
+
+			if ( item.getAttribute( 'type' ).toLowerCase() == 'text' )
+			{
+				if ( isRecover )
+				{
+					item.setAttribute( 'value', item.getCustomData( 'fake_value' ) || '' );
+					item.removeCustomData( 'fake_value' );
+				}
+				else
+				{
+					item.setCustomData( 'fake_value', item.getAttribute( 'value' ) );
+					item.setAttribute( 'value', '' );
+				}
+			}
+		}
 	}
 
@@ -487,5 +512,5 @@
 		}
 
-		this.parts['tabs'].on( 'click', function( evt )
+		this.parts[ 'tabs' ].on( 'click', function( evt )
 				{
 					var target = evt.data.getTarget();
@@ -695,9 +720,9 @@
 			this.resize( definition.minWidth, definition.minHeight );
 
+			// Reset all inputs back to their default value.
+			this.reset();
+
 			// Select the first tab by default.
 			this.selectPage( this.definition.contents[0].id );
-
-			// Reset all inputs back to their default value.
-			this.reset();
 
 			// Set z-index.
@@ -976,7 +1001,22 @@
 			}
 
-			var selected = this._.tabs[id];
-			selected[0].addClass( 'cke_dialog_tab_selected' );
-			selected[1].show();
+			var selected = this._.tabs[ id ];
+			selected[ 0 ].addClass( 'cke_dialog_tab_selected' );
+
+			// [IE] an invisible input[type='text'] will enlarge it's width
+			// if it's value is long when it shows, so we clear it's value
+			// before it shows and then recover it (#5649)
+			if ( CKEDITOR.env.ie6Compat || CKEDITOR.env.ie7Compat )
+			{
+				clearOrRecoverTextInputValue( selected[ 1 ] );
+				selected[ 1 ].show();
+				setTimeout( function()
+				{
+					clearOrRecoverTextInputValue( selected[ 1 ], 1 );
+				}, 0 );
+			}
+			else
+				selected[ 1 ].show();
+
 			this._.currentTabId = id;
 			this._.currentTabIndex = CKEDITOR.tools.indexOf( this._.tabIdList, id );
@@ -1782,7 +1822,8 @@
 	{
 		var win = CKEDITOR.document.getWindow();
-		var backgroundColorStyle = editor.config.dialog_backgroundCoverColor || 'white',
-			backgroundCoverOpacity = editor.config.dialog_backgroundCoverOpacity,
-			baseFloatZIndex = editor.config.baseFloatZIndex,
+		var config = editor.config,
+			backgroundColorStyle = config.dialog_backgroundCoverColor || 'white',
+			backgroundCoverOpacity = config.dialog_backgroundCoverOpacity,
+			baseFloatZIndex = config.baseFloatZIndex,
 			coverKey = CKEDITOR.tools.genKey(
 					backgroundColorStyle,
@@ -2215,12 +2256,12 @@
 						{
 							if ( widths[i] )
-								styles.push( 'width:' + CKEDITOR.tools.cssLength( widths[i] ) );
+								styles.push( 'width:' + cssLength( widths[i] ) );
 						}
 						else
 							styles.push( 'width:' + Math.floor( 100 / childHtmlList.length ) + '%' );
 						if ( height )
-							styles.push( 'height:' + CKEDITOR.tools.cssLength( height ) );
+							styles.push( 'height:' + cssLength( height ) );
 						if ( elementDefinition && elementDefinition.padding != undefined )
-							styles.push( 'padding:' + CKEDITOR.tools.cssLength( elementDefinition.padding ) );
+							styles.push( 'padding:' + cssLength( elementDefinition.padding ) );
 						if ( styles.length > 0 )
 							html.push( 'style="' + styles.join('; ') + '" ' );
@@ -2275,5 +2316,5 @@
 			vbox : function( dialog, childObjList, childHtmlList, htmlList, elementDefinition )
 			{
-				if (arguments.length < 3 )
+				if ( arguments.length < 3 )
 					return;
 
@@ -2290,5 +2331,5 @@
 					if ( elementDefinition && elementDefinition.expand )
 						html.push( 'height:100%;' );
-					html.push( 'width:' + CKEDITOR.tools.cssLength( width || '100%' ), ';' );
+					html.push( 'width:' + cssLength( width || '100%' ), ';' );
 					html.push( '"' );
 					html.push( 'align="', CKEDITOR.tools.htmlEncode(
@@ -2301,11 +2342,11 @@
 						html.push( '<tr><td role="presentation" ' );
 						if ( width )
-							styles.push( 'width:' + CKEDITOR.tools.cssLength( width || '100%' ) );
+							styles.push( 'width:' + cssLength( width || '100%' ) );
 						if ( heights )
-							styles.push( 'height:' + CKEDITOR.tools.cssLength( heights[i] ) );
+							styles.push( 'height:' + cssLength( heights[i] ) );
 						else if ( elementDefinition && elementDefinition.expand )
 							styles.push( 'height:' + Math.floor( 100 / childHtmlList.length ) + '%' );
 						if ( elementDefinition && elementDefinition.padding != undefined )
-							styles.push( 'padding:' + CKEDITOR.tools.cssLength( elementDefinition.padding ) );
+							styles.push( 'padding:' + cssLength( elementDefinition.padding ) );
 						if ( styles.length > 0 )
 							html.push( 'style="', styles.join( '; ' ), '" ' );
Index: CKEditor/branches/versions/3.5.x/_source/plugins/dialogadvtab/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/dialogadvtab/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/dialogadvtab/plugin.js	(revision 6050)
@@ -36,4 +36,12 @@
 		var attrName = this.att,
 			value = this.getValue();
+
+		// Broadcast Lang Dir change
+		if ( attrName == 'dir' )
+		{
+			var dir = element.getAttribute( attrName, value );
+			if ( dir != value && element.getParent() )
+					this._.dialog._.editor.fire( 'dirChanged', element );
+		}
 
 		if ( value )
@@ -99,5 +107,5 @@
 						label : lang.langDir,
 						'default' : '',
-						style : 'width:110px',
+						style : 'width:100%',
 						items :
 						[
@@ -123,5 +131,5 @@
 			contents = [];
 
-			if ( tabConfig.id )
+			if ( tabConfig.styles )
 			{
 				contents.push(
@@ -132,6 +140,4 @@
 						label : lang.styles,
 						'default' : '',
-
-						onChange : function(){},
 
 						getStyle : function( name, defaultValue )
@@ -160,5 +166,5 @@
 							}
 
-							this.setValue( styles, true );
+							this.setValue( styles, 1 );
 
 						},
Index: CKEditor/branches/versions/3.5.x/_source/plugins/dialogui/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/dialogui/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/dialogui/plugin.js	(revision 6050)
@@ -381,5 +381,5 @@
 						attributes.checked = 'checked';
 
-					if (typeof myDefinition.controlStyle != 'undefined')
+					if ( typeof myDefinition.controlStyle != 'undefined' )
 						myDefinition.style = myDefinition.controlStyle;
 
@@ -463,5 +463,5 @@
 						cleanInnerDefinition( labelDefinition );
 
-						if (typeof inputDefinition.controlStyle != 'undefined')
+						if ( typeof inputDefinition.controlStyle != 'undefined' )
 							inputDefinition.style = inputDefinition.controlStyle;
 
@@ -623,5 +623,5 @@
 					}
 
-					if (typeof myDefinition.controlStyle != 'undefined')
+					if ( typeof myDefinition.controlStyle != 'undefined' )
 						myDefinition.style = myDefinition.controlStyle;
 
@@ -932,5 +932,5 @@
 					this._.disabled = false;
 					var element = this.getElement();
-					element && element.removeClass( 'disabled' );
+					element && element.removeClass( 'cke_disabled' );
 				},
 
@@ -942,5 +942,5 @@
 				{
 					this._.disabled = true;
-					this.getElement().addClass( 'disabled' );
+					this.getElement().addClass( 'cke_disabled' );
 				},
 
@@ -1385,16 +1385,17 @@
 				reset : function()
 				{
-					var frameElement = CKEDITOR.document.getById( this._.frameId ),
+					var _ = this._,
+						frameElement = CKEDITOR.document.getById( _.frameId ),
 						frameDocument = frameElement.getFrameDocument(),
-						elementDefinition = this._.definition,
-						buttons = this._.buttons,
+						elementDefinition = _.definition,
+						buttons = _.buttons,
 						callNumber = this.formLoadedNumber,
 						unloadNumber = this.formUnloadNumber,
-						langDir = this._.dialog._.editor.lang.dir,
-						langCode = this._.dialog._.editor.langCode;
+						langDir = _.dialog._.editor.lang.dir,
+						langCode = _.dialog._.editor.langCode;
 
 					// The callback function for the iframe, but we must call tools.addFunction only once
 					// so we store the function number in this.formLoadedNumber
-					if (!callNumber)
+					if ( !callNumber )
 					{
 						callNumber = this.formLoadedNumber = CKEDITOR.tools.addFunction(
Index: CKEditor/branches/versions/3.5.x/_source/plugins/div/dialogs/div.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/div/dialogs/div.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/div/dialogs/div.js	(revision 6050)
@@ -141,6 +141,6 @@
 
 			// Get all ranges from the selection.
-			var selection = editor.document.getSelection();
-			var ranges = selection.getRanges();
+			var selection = editor.document.getSelection(),
+				ranges = selection.getRanges();
 			var bookmarks = selection.createBookmarks();
 			var i, iterator;
@@ -331,5 +331,11 @@
 									var styleName;
 									if ( ( styleName = this.getValue() ) )
-										styles[ styleName ].applyToObject( element );
+									{
+										var style = styles[ styleName ];
+										var customData = element.getCustomData( 'elementStyle' ) || '';
+
+										style.applyToObject( element );
+										element.setCustomData( 'elementStyle', customData + style._.definition.attributes.style );
+									}
 								}
 							},
@@ -387,7 +393,6 @@
 											{
 												// Merge with 'elementStyle', which is of higher priority.
-												var value = this.getValue(),
-														merged = [ value, element.getAttribute( 'style' ) ].join( ';' );
-												value && element.setAttribute( 'style', merged );
+												var merged = this.getValue() + ( element.getCustomData( 'elementStyle' ) || '' );
+												element.setAttribute( 'style', merged );
 											}
 										}
@@ -433,5 +438,5 @@
 			onLoad : function()
 			{
-				setupFields.call(this);
+				setupFields.call( this );
 
 				// Preparing for the 'elementStyle' field.
@@ -504,4 +509,7 @@
 			onHide : function()
 			{
+				// Remove style only when editing existing DIV. (#6315)
+				if ( command == 'editdiv' )
+					this._element.removeCustomData( 'elementStyle' );
 				delete this._element;
 			}
Index: CKEditor/branches/versions/3.5.x/_source/plugins/domiterator/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/domiterator/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/domiterator/plugin.js	(revision 6050)
@@ -21,9 +21,9 @@
 
 		this.range = range;
-		this.forceBrBreak = false;
+		this.forceBrBreak = 0;
 
 		// Whether include <br>s into the enlarged range.(#3730).
-		this.enlargeBr = true;
-		this.enforceRealBlocks = false;
+		this.enlargeBr = 1;
+		this.enforceRealBlocks = 0;
 
 		this._ || ( this._ = {} );
@@ -45,4 +45,7 @@
 			var isLast;
 
+			// Indicate at least one of the range boundaries is inside a preformat block.
+			var touchPre;
+
 			// Instructs to cleanup remaining BRs.
 			var removePreviousBr, removeLastBr;
@@ -56,5 +59,8 @@
 				range.shrink( CKEDITOR.NODE_ELEMENT, true );
 
-				range.enlarge( this.forceBrBreak || !this.enlargeBr ?
+				touchPre = range.endContainer.hasAscendant( 'pre', true )
+					|| range.startContainer.hasAscendant( 'pre', true );
+
+				range.enlarge( this.forceBrBreak && !touchPre || !this.enlargeBr ?
 							   CKEDITOR.ENLARGE_LIST_ITEM_CONTENTS : CKEDITOR.ENLARGE_BLOCK_CONTENTS );
 
@@ -75,5 +81,5 @@
 				if ( this._.lastNode &&
 						this._.lastNode.type == CKEDITOR.NODE_TEXT &&
-						!CKEDITOR.tools.trim( this._.lastNode.getText( ) ) &&
+						!CKEDITOR.tools.trim( this._.lastNode.getText() ) &&
 						this._.lastNode.getParent().isBlockBoundary() )
 				{
@@ -107,10 +113,11 @@
 				// closeRange indicates that a paragraph boundary has been found,
 				// so the range can be closed.
-				var closeRange = false;
+				var closeRange = 0,
+					parentPre = currentNode.hasAscendant( 'pre' );
 
 				// includeNode indicates that the current node is good to be part
 				// of the range. By default, any non-element node is ok for it.
 				var includeNode = ( currentNode.type != CKEDITOR.NODE_ELEMENT ),
-					continueFromSibling = false;
+					continueFromSibling = 0;
 
 				// If it is an element node, let's check if it can be part of the
@@ -120,10 +127,11 @@
 					var nodeName = currentNode.getName();
 
-					if ( currentNode.isBlockBoundary( this.forceBrBreak && { br : 1 } ) )
+					if ( currentNode.isBlockBoundary( this.forceBrBreak &&
+							!parentPre && { br : 1 } ) )
 					{
 						// <br> boundaries must be part of the range. It will
 						// happen only if ForceBrBreak.
 						if ( nodeName == 'br' )
-							includeNode = true;
+							includeNode = 1;
 						else if ( !range && !currentNode.getChildCount() && nodeName != 'hr' )
 						{
@@ -147,5 +155,5 @@
 						}
 
-						closeRange = true;
+						closeRange = 1;
 					}
 					else
@@ -164,5 +172,5 @@
 							continue;
 						}
-						includeNode = true;
+						includeNode = 1;
 					}
 				}
@@ -172,5 +180,5 @@
 					// other unicode whitespaces) before/after a block node.
 					if ( beginWhitespaceRegex.test( currentNode.getText() ) )
-						includeNode = false;
+						includeNode = 0;
 				}
 
@@ -194,7 +202,8 @@
 						var parentNode = currentNode.getParent();
 
-						if ( parentNode.isBlockBoundary( this.forceBrBreak && { br : 1 } ) )
+						if ( parentNode.isBlockBoundary( this.forceBrBreak
+								&& !parentPre && { br : 1 } ) )
 						{
-							closeRange = true;
+							closeRange = 1;
 							isLast = isLast || ( parentNode.equals( lastNode) );
 							break;
@@ -202,7 +211,7 @@
 
 						currentNode = parentNode;
-						includeNode = true;
+						includeNode = 1;
 						isLast = ( currentNode.equals( lastNode ) );
-						continueFromSibling = true;
+						continueFromSibling = 1;
 					}
 				}
@@ -294,4 +303,7 @@
 			}
 
+			// Ignore bookmark nodes.(#3783)
+			var bookmarkGuard = CKEDITOR.dom.walker.bookmark( false, true );
+
 			if ( removePreviousBr )
 			{
@@ -308,7 +320,4 @@
 			if ( removeLastBr )
 			{
-				// Ignore bookmark nodes.(#3783)
-				var bookmarkGuard = CKEDITOR.dom.walker.bookmark( false, true );
-
 				var lastChild = block.getLast();
 				if ( lastChild && lastChild.type == CKEDITOR.NODE_ELEMENT && lastChild.getName() == 'br' )
@@ -331,4 +340,10 @@
 			}
 
+			if ( !bookmarkGuard( this._.nextNode ) )
+			{
+				this._.nextNode = this._.nextNode.getNextSourceNode( true, null, function( node )
+					{ return !node.equals( lastNode ) && bookmarkGuard( node ); } );
+			}
+
 			return block;
 		}
Index: CKEditor/branches/versions/3.5.x/_source/plugins/editingblock/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/editingblock/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/editingblock/plugin.js	(revision 6050)
@@ -111,5 +111,5 @@
 						editor.fireOnce( 'instanceReady' );
 						CKEDITOR.fire( 'instanceReady', null, editor );
-					} );
+					}, 0 );
 				});
 		}
@@ -212,5 +212,4 @@
  * config.startupFocus = true;
  */
-CKEDITOR.config.startupFocus = false;
 
 /**
Index: CKEditor/branches/versions/3.5.x/_source/plugins/enterkey/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/enterkey/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/enterkey/plugin.js	(revision 6050)
@@ -70,5 +70,5 @@
 				{
 					nextBlock.breakParent( node );
-					nextBlock.move( nextBlock.getNext(), true );
+					nextBlock.move( nextBlock.getNext(), 1 );
 				}
 			}
@@ -318,5 +318,5 @@
 		}
 		else
-			return enter( editor, editor.config.shiftEnterMode, true );
+			return enter( editor, editor.config.shiftEnterMode, 1 );
 	}
 
@@ -336,5 +336,5 @@
 			{
 				editor.fire( 'saveSnapshot' );	// Save undo step.
-				if ( mode == CKEDITOR.ENTER_BR || editor.getSelection().getStartElement().hasAscendant( 'pre', true ) )
+				if ( mode == CKEDITOR.ENTER_BR || editor.getSelection().getStartElement().hasAscendant( 'pre', 1 ) )
 					enterBr( editor, mode, null, forceMode );
 				else
Index: CKEditor/branches/versions/3.5.x/_source/plugins/entities/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/entities/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/entities/plugin.js	(revision 6050)
@@ -6,9 +6,8 @@
 (function()
 {
+	// Base HTML entities.
+	var htmlbase = 'nbsp,gt,lt,quot';
+
 	var entities =
-
-		// Base HTML entities.
-		'nbsp,gt,lt,quot,' +
-
 		// Latin-1 Entities
 		'iexcl,cent,pound,curren,yen,brvbar,sect,uml,copy,ordf,laquo,' +
@@ -47,5 +46,9 @@
 		'upsih,piv';
 
-	function buildTable( entities )
+	/**
+	 * Create a mapping table between one character and it's entity form from a list of entity names.
+	 * @param reverse {Boolean} Whether create a reverse map from the entity string form to actual character.
+	 */
+	function buildTable( entities, reverse )
 	{
 		var table = {},
@@ -64,29 +67,35 @@
 		entities = entities.replace( /\b(nbsp|shy|gt|lt|amp)(?:,|$)/g, function( match, entity )
 			{
-				table[ specialTable[ entity ] ] = '&' + entity + ';';
-				regex.push( specialTable[ entity ] );
+				var org = reverse ? '&' + entity + ';' : specialTable[ entity ],
+					result = reverse ? specialTable[ entity ] : '&' + entity + ';';
+
+				table[ org ] = result;
+				regex.push( org );
 				return '';
 			});
 
-		// Transforms the entities string into an array.
-		entities = entities.split( ',' );
-
-		// Put all entities inside a DOM element, transforming them to their
-		// final chars.
-		var div = document.createElement( 'div' ),
-			chars;
-		div.innerHTML = '&' + entities.join( ';&' ) + ';';
-		chars = div.innerHTML;
-		div = null;
-
-		// Add all chars to the table.
-		for ( var i = 0 ; i < chars.length ; i++ )
+		if ( !reverse )
 		{
-			var charAt = chars.charAt( i );
-			table[ charAt ] = '&' + entities[ i ] + ';';
-			regex.push( charAt );
+			// Transforms the entities string into an array.
+			entities = entities.split( ',' );
+
+			// Put all entities inside a DOM element, transforming them to their
+			// final chars.
+			var div = document.createElement( 'div' ),
+				chars;
+			div.innerHTML = '&' + entities.join( ';&' ) + ';';
+			chars = div.innerHTML;
+			div = null;
+
+			// Add all chars to the table.
+			for ( var i = 0 ; i < chars.length ; i++ )
+			{
+				var charAt = chars.charAt( i );
+				table[ charAt ] = '&' + entities[ i ] + ';';
+				regex.push( charAt );
+			}
 		}
 
-		table.regex = regex.join( '' );
+		table.regex = regex.join( reverse ? '|' : '' );
 
 		return table;
@@ -99,7 +108,4 @@
 			var config = editor.config;
 
-			if ( !config.entities )
-				return;
-
 			var dataProcessor = editor.dataProcessor,
 				htmlFilter = dataProcessor && dataProcessor.htmlFilter;
@@ -107,14 +113,19 @@
 			if ( htmlFilter )
 			{
-				var selectedEntities = entities;
-
-				if ( config.entities_latin )
-					selectedEntities += ',' + latin;
-
-				if ( config.entities_greek )
-					selectedEntities += ',' + greek;
-
-				if ( config.entities_additional )
-					selectedEntities += ',' + config.entities_additional;
+				// Mandatory HTML base entities.
+				var selectedEntities = htmlbase;
+
+				if ( config.entities )
+				{
+					selectedEntities += ',' + entities;
+					if ( config.entities_latin )
+						selectedEntities += ',' + latin;
+
+					if ( config.entities_greek )
+						selectedEntities += ',' + greek;
+
+					if ( config.entities_additional )
+						selectedEntities += ',' + config.entities_additional;
+				}
 
 				var entitiesTable = buildTable( selectedEntities );
@@ -124,12 +135,24 @@
 				delete entitiesTable.regex;
 
-				if ( config.entities_processNumerical )
+				if ( config.entities && config.entities_processNumerical )
 					entitiesRegex = '[^ -~]|' + entitiesRegex ;
 
 				entitiesRegex = new RegExp( entitiesRegex, 'g' );
+
+				function getEntity( character )
+				{
+					return config.entities_processNumerical == 'force' || !entitiesTable[ character ] ?
+						   '&#' + character.charCodeAt(0) + ';'
+							: entitiesTable[ character ];
+				}
+
+				// Decode entities that the browsers has transformed
+				// at first place.
+				var baseEntitiesTable = buildTable( [ htmlbase, 'shy' ].join( ',' ) , true ),
+					baseEntitiesRegex = new RegExp( baseEntitiesTable.regex, 'g' );
 
 				function getChar( character )
 				{
-					return entitiesTable[ character ] || ( '&#' + character.charCodeAt(0) + ';' );
+					return baseEntitiesTable[ character ];
 				}
 
@@ -138,5 +161,6 @@
 						text : function( text )
 						{
-							return text.replace( entitiesRegex, getChar );
+							return text.replace( baseEntitiesRegex, getChar )
+									.replace( entitiesRegex, getEntity );
 						}
 					});
@@ -180,13 +204,15 @@
 /**
  * Whether to convert all remaining characters, not comprised in the ASCII
- * character table, to their relative numeric representation of HTML entity.
+ * character table, to their relative decimal numeric representation of HTML entity.
+ * When specified as the value 'force', it will simply convert all entities into the above form.
  * For example, the phrase "This is Chinese: &#27721;&#35821;." is outputted
  * as "This is Chinese: &amp;#27721;&amp;#35821;."
  * @type Boolean
+ * @type Boolean|String
  * @default false
  * @example
  * config.entities_processNumerical = true;
- */
-CKEDITOR.config.entities_processNumerical = false;
+ * config.entities_processNumerical = 'force';		//Convert from "&nbsp;" into "&#160;";
+ */
 
 /**
Index: CKEditor/branches/versions/3.5.x/_source/plugins/filebrowser/plugin.js
===================================================================
--- CKEditor/branches/versions/3.5.x/_source/plugins/filebrowser/plugin.js	(revision 5937)
+++ CKEditor/branches/versions/3.5.x/_source/plugins/filebrowser/plugin.js	(revision 6050)
@@ -262,6 +262,11 @@
 			if ( element.filebrowser.action == 'Browse' )
 			{
-				var url = element.filebrowser.url || editor.config[ 'filebrowser' + ucFirst( dialogName ) + 'BrowseUrl' ]
-							|| editor.config.filebrowserBrowseUrl;
+				var url = element.filebrowser.url;
+				if ( url === undefined )
+				{
+					url = editor.config[ 'filebrowser' + ucFirst( dialogName ) + 'BrowseUrl' ];
+					if ( url === undefined )
+						url = editor.config.filebrowserBrowseUrl;
+				}
 
 				if ( url )
@@ -274,6 +279,11 @@
 			else if ( element.filebrowser.action == 'QuickUpload' && element[ 'for' ] )
 			{
-				url =  element.filebrowser.url || editor.config[ 'filebrowser' + ucFirst( dialogName ) + 'UploadUrl' ]
-							|| editor.config.filebrowserUploadUrl;
+				var url = element.filebrowser.url;
+				if ( url === undefined )
+				{
+					url = editor.config[ 'filebrowser' + ucFirst( dialogName ) + 'UploadUrl' ];
+					if ( url === undefined )
+						url = editor.config.filebrowserUploadUrl;
+				}
 
 				if ( url )
@@ -341,5 +351,5 @@
 			for ( var i = 0 ; i < ids.length ; i++ )
 			{
-				if ( isConfigured( definition, tabId, ids[i]) )
+				if ( isConfigured( definition, tabId, ids[i] ) )
 					return true;
 			}
